# Linux 系统基础知识

> who ---> 查看谁登陆了系统  
> cal ---> 查看日历  
> date ---> 查看当前时间  
> Tab ---> 制表建查看和补全

### Linux 命令格式
命令 【参数】【作用到对象】  
> who am i ---> 查看自己什么时候登陆到  
> cal 2019 ---> 查看2019年全年日历  
> pwd ---> print working directory ---> 显示当前所在路径  
> cd ---> change directory ---> 改变目录  
 > * .. ---> 上级目录  
 > * . ---> 当前目录
        
> ls ---> list directory contents ---> 列出目录下的内容（文件和文件夹）  
 > * 以点开头的文件和文件夹在Linux系统上是隐藏文件  
 > * ls -la ---> 列出文件列表（包括隐藏文件）  

> clear ---> 清屏  

> touch hello.txt ---> 创建一个空文件  

> mkdir ---> 创建文件夹  

> mkdir -p efg/hello

> rmdir ---> 删除空文件夹 

> rm --->  删除文件有提示

> rm -f 强制删除不提示

> rm -r 删除文件夹

> cp ---> 文件拷贝

> mv ---> 移动文件

> cat 连接多个文件（只有一个文件就是查看文件）

> wget ---> 拿网络文件

> more / less 分屏查看文件

> tar -cf hello.tar --->   归档

> tar -xf hello.tar ---> 解归档

> gzip ---> 压缩

> gunzip ---> 解压缩

> xz -z ---> 压缩

> xz -d ---> 解压缩

> man ---> 帮助手册

> help ---> 查看命令帮助

> whereis ---> 查看命令的路径

> whatis ---> 查看命令的说明

> history ---> 查看历史命令

> history ---> 清除历史命令
### Linux安装软件或者服务
1. 使用包管理安装 ---> 软件管家（查找丶安装丶卸载丶更新丶查看信息丶查看已安装）
   * rpm: Redhat Package Manager
   * yum: Yellowdog Updater Modified
   * 云服务器 ---> Nginx / Apache / Tengine ---> Web服务器
   * yum search nginx ---> 搜索Nginx
   * yum install nginx  ---> 安装nginx
   * yum info nginx ---> 查看nginx信息
   * yum erase nginx / yum remove nginx ---> 卸载nginx
   * yum update nginx ---> 更新nginx
   * yum list installed ---> 查看所以安装的软件
   * yum list installed | grep nginx ---> 管道查询
   * systemctl start nginx ---> 启动Nginx服务器
   * systemctl stop nginx ---> 停止Nginx服务器
   * systemctl restart nginx ---> 重启Nginx服务器
   * systemctl status nginx ---> 查看Nginx服务器
   * /usr/share/nginx/html ---> nginx的html代码路径
2. 源代码构建安装
   * 安装python3 ---> CPython ---> python.org下载Cpython源代码安装
   1. gcc ---> C语言的编译器 / make --->  C语言的构建语言
      * yum install -y gcc
      * yum update -y gcc
   2. 解压缩和解归档
      * xz -d Python-3.8.2.tar.xz / gunzip Python-3.8.2.tar.xz
      * tar -xf Python-3.8.2.tar
   3. 进入文件夹
      * cd Python-3.8.2
   4. 执行安装前的准备工作（补充CPython底层依赖项）
      * yum -y install zlib-devel bzip2-devel openssl-devel ncurses-devel sqlite-devel readline-devel tk-devel gdbm-devel db4-devel libpcap-devel xz-devel
    5. 安装全的配置  
       * ./configure --prefix=/usr/local/python3 --enable-optimizations
    6. 构建和安装
       * make && make install
    7. 配置环境变量
3. 直接下载二进制程序

### Linux 系统文本编辑工具（神器）---> vim
1. 三种工作模式
 * 命令模式：你的安静操作都是命令
   * hjkl - 移动光标 - 100j / 50k
   * $ - 行尾 0 - 行首
   * dd - 删除整行
   * u - 撤销
   * ZZ ---> 保存退出
 * 末行模式:
   * set ts=4 ---> 设置制表建（Tab）的空格为4个空格
   * set nu ---> 显示行号
   * set autoindent ---> 设置自动缩进
   * wq 保存退出
 * 编辑模式：编辑内容
   * i / a / o ---> 编辑模式
   * ESC ---> 回到命令模式
   
### linux安装mysql

1. wget https://downloads.mysql.com/archives/get/p/23/file/mysql-5.7.30-1.el7.x86_64.rpm-bundle.tar  ---> 下载mysql
2. tar -xf mysql-5.7.30-1.el7.x86_64.rpm-bundle.tar -C mysql --->  解压到mysql文件夹  
3. yum list installed | grep mariadb  --->  检查有没有mariadb  
4. yum erase -y mariadb-libs ---> 移除mariadb
5. rpm -ivh mysql-community-common-5.7.30-1.el7.x86_64.rpm --->安装common包  
6. rpm -ivh mysql-community-libs-5.7.30-1.el7.x86_64.rpm ---> 安装libs包  
7. rpm -ivh mysql-community-libs-compat-5.7.30-1.el7.x86_64.rpm ---> 安装libs-compat包
8. rpm -ivh mysql-community-devel-5.7.30-1.el7.x86_64.rpm ---> 安装devel包
9. rpm -ivh mysql-community-client-5.7.30-1.el7.x86_64.rpm ---> 安装client包
10. rpm -ivh mysql-community-server-5.7.30-1.el7.x86_64.rpm ---> 安装server包









